Index: misc/publications/2015/journals/AAI/Instance_1.1.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1.1.txt	(revision 13488)
+++ 	(revision )
@@ -1,40 +1,0 @@
-1	2015.07.10 08:31:09	1
-2	2015.07.10 08:35:30	1
-3	2015.07.10 08:44:00	1
-4	2015.07.10 13:36:14	1
-5	2015.07.10 14:25:18	1
-6	2015.07.10 14:54:30	1
-7	2015.07.10 15:04:42	1
-8	2015.07.10 15:17:48	1
-9	2015.07.10 15:35:29	1
-10	2015.07.10 15:44:08	1
-11	2015.07.10 15:53:04	1
-12	2015.07.10 16:01:56	1
-13	2015.07.10 16:11:09	1
-8	2015.07.10 16:14:30	2
-6	2015.07.10 16:14:30	2
-4	2015.07.10 16:14:30	2
-14	2015.07.10 16:18:24	1
-15	2015.07.10 16:33:04	1
-16	2015.07.10 16:40:31	1
-17	2015.07.10 16:48:58	1
-12	2015.07.10 17:35:45	2
-9	2015.07.10 17:35:45	2
-5	2015.07.10 17:35:45	2
-14	2015.07.10 17:47:40	2
-13	2015.07.10 17:47:40	2
-11	2015.07.10 17:47:40	2
-15	2015.07.10 18:06:53	2
-10	2015.07.10 18:06:53	2
-7	2015.07.10 18:06:53	2
-1	2015.07.10 18:18:37	2
-2	2015.07.10 18:18:37	2
-3	2015.07.10 18:18:37	2
-17	2015.07.10 18:18:38	2
-16	2015.07.10 18:18:38	2
-18	2015.07.10 21:14:42	1
-19	2015.07.10 21:28:25	1
-20	2015.07.10 21:56:29	1
-20	2015.07.10 22:18:07	2
-19	2015.07.10 22:18:07	2
-18	2015.07.10 22:18:07	2
Index: misc/publications/2015/journals/AAI/Instance_1.2.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1.2.txt	(revision 13488)
+++ 	(revision )
@@ -1,40 +1,0 @@
-1	10.07.2015 08:31	1
-2	10.07.2015 08:35	1
-3	10.07.2015 08:44	1
-4	10.07.2015 13:36	1
-5	10.07.2015 14:25	1
-6	10.07.2015 14:54	1
-7	10.07.2015 15:04	1
-8	10.07.2015 15:17	1
-9	10.07.2015 15:35	1
-10	10.07.2015 15:44	1
-11	10.07.2015 15:53	1
-12	10.07.2015 16:01	1
-13	10.07.2015 16:11	1
-14	10.07.2015 16:14	1
-15	10.07.2015 16:14	1
-16	10.07.2015 16:14	1
-17	10.07.2015 16:18	1
-18	10.07.2015 16:33	1
-19	10.07.2015 16:40	1
-20	10.07.2015 16:48	1
-8	10.07.2015 17:35	2
-6	10.07.2015 17:35	2
-4	10.07.2015 17:35	2
-12	10.07.2015 17:47	2
-9	10.07.2015 17:47	2
-5	10.07.2015 17:47	2
-14	10.07.2015 18:06	2
-13	10.07.2015 18:06	2
-11	10.07.2015 18:06	2
-15	10.07.2015 18:18	2
-10	10.07.2015 18:18	2
-7	10.07.2015 18:18	2
-1	10.07.2015 18:18	2
-2	10.07.2015 18:18	2
-3	10.07.2015 21:14	2
-17	10.07.2015 21:14	2
-16	10.07.2015 21:14	2
-20	10.07.2015 22:18	2
-19	10.07.2015 22:18	2
-18	10.07.2015 22:18	2
Index: misc/publications/2015/journals/AAI/Instance_1.3.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1.3.txt	(revision 13488)
+++ 	(revision )
@@ -1,40 +1,0 @@
-1	10.07.2015 08:31	1
-2	10.07.2015 08:35	1
-3	10.07.2015 08:44	1
-4	10.07.2015 13:36	1
-6	10.07.2015 14:25	1
-8	10.07.2015 14:54	1
-8	10.07.2015 15:04	2
-6	10.07.2015 15:04	2
-4	10.07.2015 15:04	2
-5	10.07.2015 15:44	1
-7	10.07.2015 15:53	1
-9	10.07.2015 16:01	1
-12	10.07.2015 16:11	1
-12	10.07.2015 16:14	2
-9	10.07.2015 16:14	2
-5	10.07.2015 16:14	2
-10	10.07.2015 16:18	1
-11	10.07.2015 16:33	1
-13	10.07.2015 16:40	1
-14	10.07.2015 16:48	1
-14	10.07.2015 17:35	2
-13	10.07.2015 17:35	2
-11	10.07.2015 17:35	2
-15	10.07.2015 17:40	1
-15	10.07.2015 17:47	2
-10	10.07.2015 17:47	2
-7	10.07.2015 17:47	2
-1	10.07.2015 18:06	2
-2	10.07.2015 18:06	2
-3	10.07.2015 18:06	2
-16	10.07.2015 18:18	1
-17	10.07.2015 18:38	1
-17	10.07.2015 19:18	2
-16	10.07.2015 19:18	2
-18	10.07.2015 21:14	1
-19	10.07.2015 21:28	1
-20	10.07.2015 21:56	1
-20	10.07.2015 22:18	2
-19	10.07.2015 22:18	2
-18	10.07.2015 22:18	2
Index: misc/publications/2015/journals/AAI/Instance_1_1.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1_1.txt	(revision 13489)
+++ misc/publications/2015/journals/AAI/Instance_1_1.txt	(revision 13489)
@@ -0,0 +1,40 @@
+1	2015.07.10 08:31:09	1
+2	2015.07.10 08:35:30	1
+3	2015.07.10 08:44:00	1
+4	2015.07.10 13:36:14	1
+5	2015.07.10 14:25:18	1
+6	2015.07.10 14:54:30	1
+7	2015.07.10 15:04:42	1
+8	2015.07.10 15:17:48	1
+9	2015.07.10 15:35:29	1
+10	2015.07.10 15:44:08	1
+11	2015.07.10 15:53:04	1
+12	2015.07.10 16:01:56	1
+13	2015.07.10 16:11:09	1
+8	2015.07.10 16:14:30	2
+6	2015.07.10 16:14:30	2
+4	2015.07.10 16:14:30	2
+14	2015.07.10 16:18:24	1
+15	2015.07.10 16:33:04	1
+16	2015.07.10 16:40:31	1
+17	2015.07.10 16:48:58	1
+12	2015.07.10 17:35:45	2
+9	2015.07.10 17:35:45	2
+5	2015.07.10 17:35:45	2
+14	2015.07.10 17:47:40	2
+13	2015.07.10 17:47:40	2
+11	2015.07.10 17:47:40	2
+15	2015.07.10 18:06:53	2
+10	2015.07.10 18:06:53	2
+7	2015.07.10 18:06:53	2
+1	2015.07.10 18:18:37	2
+2	2015.07.10 18:18:37	2
+3	2015.07.10 18:18:37	2
+17	2015.07.10 18:18:38	2
+16	2015.07.10 18:18:38	2
+18	2015.07.10 21:14:42	1
+19	2015.07.10 21:28:25	1
+20	2015.07.10 21:56:29	1
+20	2015.07.10 22:18:07	2
+19	2015.07.10 22:18:07	2
+18	2015.07.10 22:18:07	2
Index: misc/publications/2015/journals/AAI/Instance_1_2.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1_2.txt	(revision 13489)
+++ misc/publications/2015/journals/AAI/Instance_1_2.txt	(revision 13489)
@@ -0,0 +1,40 @@
+1	10.07.2015 08:31	1
+2	10.07.2015 08:35	1
+3	10.07.2015 08:44	1
+4	10.07.2015 13:36	1
+5	10.07.2015 14:25	1
+6	10.07.2015 14:54	1
+7	10.07.2015 15:04	1
+8	10.07.2015 15:17	1
+9	10.07.2015 15:35	1
+10	10.07.2015 15:44	1
+11	10.07.2015 15:53	1
+12	10.07.2015 16:01	1
+13	10.07.2015 16:11	1
+14	10.07.2015 16:14	1
+15	10.07.2015 16:14	1
+16	10.07.2015 16:14	1
+17	10.07.2015 16:18	1
+18	10.07.2015 16:33	1
+19	10.07.2015 16:40	1
+20	10.07.2015 16:48	1
+8	10.07.2015 17:35	2
+6	10.07.2015 17:35	2
+4	10.07.2015 17:35	2
+12	10.07.2015 17:47	2
+9	10.07.2015 17:47	2
+5	10.07.2015 17:47	2
+14	10.07.2015 18:06	2
+13	10.07.2015 18:06	2
+11	10.07.2015 18:06	2
+15	10.07.2015 18:18	2
+10	10.07.2015 18:18	2
+7	10.07.2015 18:18	2
+1	10.07.2015 18:18	2
+2	10.07.2015 18:18	2
+3	10.07.2015 21:14	2
+17	10.07.2015 21:14	2
+16	10.07.2015 21:14	2
+20	10.07.2015 22:18	2
+19	10.07.2015 22:18	2
+18	10.07.2015 22:18	2
Index: misc/publications/2015/journals/AAI/Instance_1_3.txt
===================================================================
--- misc/publications/2015/journals/AAI/Instance_1_3.txt	(revision 13489)
+++ misc/publications/2015/journals/AAI/Instance_1_3.txt	(revision 13489)
@@ -0,0 +1,40 @@
+1	10.07.2015 08:31	1
+2	10.07.2015 08:35	1
+3	10.07.2015 08:44	1
+4	10.07.2015 13:36	1
+6	10.07.2015 14:25	1
+8	10.07.2015 14:54	1
+8	10.07.2015 15:04	2
+6	10.07.2015 15:04	2
+4	10.07.2015 15:04	2
+5	10.07.2015 15:44	1
+7	10.07.2015 15:53	1
+9	10.07.2015 16:01	1
+12	10.07.2015 16:11	1
+12	10.07.2015 16:14	2
+9	10.07.2015 16:14	2
+5	10.07.2015 16:14	2
+10	10.07.2015 16:18	1
+11	10.07.2015 16:33	1
+13	10.07.2015 16:40	1
+14	10.07.2015 16:48	1
+14	10.07.2015 17:35	2
+13	10.07.2015 17:35	2
+11	10.07.2015 17:35	2
+15	10.07.2015 17:40	1
+15	10.07.2015 17:47	2
+10	10.07.2015 17:47	2
+7	10.07.2015 17:47	2
+1	10.07.2015 18:06	2
+2	10.07.2015 18:06	2
+3	10.07.2015 18:06	2
+16	10.07.2015 18:18	1
+17	10.07.2015 18:38	1
+17	10.07.2015 19:18	2
+16	10.07.2015 19:18	2
+18	10.07.2015 21:14	1
+19	10.07.2015 21:28	1
+20	10.07.2015 21:56	1
+20	10.07.2015 22:18	2
+19	10.07.2015 22:18	2
+18	10.07.2015 22:18	2